#include <sys/param.h>
#include <sys/systm.h>
#include <sys/malloc.h>
#include "tcfs_cipher.h"
#include "ciphers/blowfish.h"


void *BLOWFISH_init_key (char *key)
{
	BF_KEY *ks=NULL;

	ks=(BF_KEY *)malloc (sizeof (BF_KEY),M_FREE,M_NOWAIT);
	if (!ks) {
		return NULL;
	}

	BF_set_key (ks, BLOWFISH_KEYSIZE, key);

	return (void *)ks;
}
void BLOWFISH_cleanup_key(void *k)
{
	free((BF_KEY*)k,M_FREE);
}

void BLOWFISH_encrypt(char *block, int nb, void *key)
{
	char iv[]={'\0','\0','\0','\0','\0','\0','\0','\0'};
	BF_cbc_encrypt(block,block,(long)nb,(BF_KEY*)key,iv,BF_ENCRYPT);
}

void BLOWFISH_decrypt(char *block, int nb, void *key)
{
	char iv[]={'\0','\0','\0','\0','\0','\0','\0','\0'};
	BF_cbc_encrypt(block,block,(long)nb,(BF_KEY*)key,iv,BF_DECRYPT);
}
